org.firstinspires.ftc.robotcore.external.navigation

## Class Quaternion

- java.lang.Object
- - org.firstinspires.ftc.robotcore.external.navigation.Quaternion

-     public class Quaternion
      extends java.lang.Object

  A `Quaternion` can indicate an orientation in three-space without the trouble of possible gimbal-lock.
  See Also:
    https://en.wikipedia.org/wiki/Quaternion, https://en.wikipedia.org/wiki/Gimbal_lock, https://www.youtube.com/watch?v=zc8b2Jo7mno, https://www.youtube.com/watch?v=mHVwd8gYLnI

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `long` | `acquisitionTime` the time on the System.nanoTime() clock at which the data was acquired.
    `float` | `w`
    `float` | `x`
    `float` | `y`
    `float` | `z`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Quaternion()`
    `Quaternion(float w, float x, float y, float z, long acquisitionTime)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Quaternion` | `congugate()`
    `float` | `magnitude()`
    `Quaternion` | `normalized()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### w

          public float w

    - #### x

          public float x

    - #### y

          public float y

    - #### z

          public float z

    - #### acquisitionTime

          public long acquisitionTime

      the time on the System.nanoTime() clock at which the data was acquired. If no timestamp is associated with this particular set of data, this value is zero.

  - ### Constructor Detail

    - #### Quaternion

          public Quaternion()

    - #### Quaternion

          public Quaternion(float w,
                            float x,
                            float y,
                            float z,
                            long acquisitionTime)

  - ### Method Detail

    - #### magnitude

          public float magnitude()

    - #### normalized

          public Quaternion normalized()

    - #### congugate

          public Quaternion congugate()